diff -r ec894ddf18f6 trytond/modules/calendar/calendar_.py
--- a/trytond/modules/calendar/calendar_.py	Wed Jul 25 20:55:21 2012 +0200
+++ b/trytond/modules/calendar/calendar_.py	Mon Sep 24 20:36:40 2012 +0200
@@ -2013,59 +1857,52 @@
     event = fields.Many2One('calendar.event', 'Event', ondelete='CASCADE',
             select=True, required=True)
 
-    def create(self, values):
-        event_obj = Pool().get('calendar.event')
+    @classmethod
+    def create(cls, values):
+        Event = Pool().get('calendar.event')
         if values.get('event'):
             # Update write_date of event
-            event_obj.write(values['event'], {})
-        return super(EventRRule, self).create(values)
+            Event.write([Event(values['event'])], {})
+        return super(EventRRule, cls).create(values)
 
-    def write(self, ids, values):
-        event_obj = Pool().get('calendar.event')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_ids = [x.event.id for x in self.browse(ids)]
+    @classmethod
+    def write(cls, event_rrules, values):
+        Event = Pool().get('calendar.event')
+        events = [x.event for x in event_rrules]
         if values.get('event'):
-            event_ids.append(values['event'])
-        if event_ids:
+            events.append(Event(values['event']))
+        if events:
             # Update write_date of event
-            event_obj.write(event_ids, {})
-        return super(EventRRule, self).write(ids, values)
+            Event.write(events, {})
+        super(EventRRule, cls).write(event_rrules, values)
 
-    def delete(self, ids):
-        event_obj = Pool().get('calendar.event')
-        rrule_obj = Pool().get('calendar.rrule')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_rrules = self.browse(ids)
-        rrule_ids = [a.calendar_rrule.id for a in event_rrules]
-        event_ids = [x.event.id for x in event_rrules]
-        if event_ids:
+    @classmethod
+    def delete(cls, event_rrules):
+        pool = Pool()
+        Event = pool.get('calendar.event')
+        Rrule = pool.get('calendar.rrule')
+        rrules = [a.calendar_rrule for a in event_rrules]
+        events = [x.event for x in event_rrules]
+        if events:
             # Update write_date of event
-            event_obj.write(event_ids, {})
-        res = super(EventRRule, self).delete(ids)
-        if rrule_ids:
-            rrule_obj.delete(rrule_ids)
-        return res
+            Event.write(events, {})
+        super(EventRRule, cls).delete(event_rrules)
+        if rrules:
+            Rrule.delete(rrules)
 
-    def _rule2update(self, rule):
-        rule_obj = Pool().get('calendar.rrule')
-        return rule_obj._rule2update(rule)
+    def _rule2update(self):
+        return self.calendar_rrule._rule2update()
 
+    @classmethod
     def rule2values(self, rule):
-        rule_obj = Pool().get('calendar.rrule')
-        return rule_obj.rule2values(rule)
+        Rule = Pool().get('calendar.rrule')
+        return Rule.rule2values(rule)
 
-    def rule2rule(self, rule):
-        rule_obj = Pool().get('calendar.rrule')
-        return rule_obj.rule2rule(rule)
-
-EventRRule()
+    def rule2rule(self):
+        return self.calendar_rrule.rule2rule()
 
 
 class EventExRule(EventRRule):
     'Exception Rule'
-    _description = __doc__
-    _name = 'calendar.event.exrule'
-
-EventExRule()
+    __name__ = 'calendar.event.exrule'
+    _table = 'calendar_event_exrule'  # Needed to override EventRRule._table
diff -r ec894ddf18f6 trytond/modules/calendar/res.py
--- a/trytond/modules/calendar/res.py	Wed Jul 25 20:55:21 2012 +0200
+++ b/trytond/modules/calendar/res.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,27 +1,26 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
-from trytond.model import ModelView, ModelSQL, fields
+from trytond.model import fields
+from trytond.pool import PoolMeta
 from trytond.pyson import Bool, Eval
 
+__all__ = ['User']
+__metaclass__ = PoolMeta
 
-class User(ModelSQL, ModelView):
-    _name = 'res.user'
+
+class User:
+    __name__ = 'res.user'
 
     calendars = fields.One2Many('calendar.calendar', 'owner', 'Calendars')
 
-    def __init__(self):
-        super(User, self).__init__()
-        self.email = copy.copy(self.email)
-        self.email.states = copy.copy(self.email.states)
-        self.email.depends = copy.copy(self.email.depends)
+    @classmethod
+    def __setup__(cls):
+        super(User, cls).__setup__()
         required = Bool(Eval('calendars'))
-        if not self.email.states.get('required'):
-            self.email.states['required'] = required
+        if not cls.email.states.get('required'):
+            cls.email.states['required'] = required
         else:
-            self.email.states['required'] = (
-                self.email.states['required'] | required)
-        if 'calendars' not in self.email.depends:
-            self.email.depends.append('calendars')
-
-User()
+            cls.email.states['required'] = (
+                cls.email.states['required'] | required)
+        if 'calendars' not in cls.email.depends:
+            cls.email.depends.append('calendars')
diff -r ec894ddf18f6 trytond/modules/calendar/webdav.py
--- a/trytond/modules/calendar/webdav.py	Wed Jul 25 20:55:21 2012 +0200
+++ b/trytond/modules/calendar/webdav.py	Mon Sep 24 20:36:40 2012 +0200
@@ -3,11 +3,13 @@
 import vobject
 import urllib
 from pywebdav.lib.errors import DAV_NotFound, DAV_Forbidden
-from trytond.model import ModelView, ModelSQL
 from trytond.tools import reduce_ids
 from trytond.cache import Cache
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
+
+__all__ = ['Collection']
+__metaclass__ = PoolMeta
 
 CALDAV_NS = 'urn:ietf:params:xml:ns:caldav'
 
@@ -45,19 +47,16 @@
             ]]
 
 
-class Collection(ModelSQL, ModelView):
+class Collection:
+    __name__ = "webdav.collection"
+    _event_cache = Cache('webdav_collection.event')
 
-    _name = "webdav.collection"
-
-    def calendar(self, uri, ics=False):
+    @staticmethod
+    def calendar(uri, ics=False):
         '''
         Return the calendar id in the uri
-
-        :param uri: the uri
-        :return: calendar id
-            or None if there is no calendar
         '''
-        calendar_obj = Pool().get('calendar.calendar')
+        Calendar = Pool().get('calendar.calendar')
 
         if uri and uri.startswith('Calendars/'):
             calendar, uri = (uri[10:].split('/', 1) + [None])[0:2]
@@ -66,40 +65,41 @@
                     calendar = calendar[:-4]
                 else:
                     return None
-            return calendar_obj.get_name(calendar)
+            return Calendar.get_name(calendar)
 
-    @Cache('webdav_collection.event')
-    def event(self, uri, calendar_id=False):
+    @classmethod
+    def event(cls, uri, calendar_id=False):
         '''
         Return the event id in the uri
+        '''
+        Event = Pool().get('calendar.event')
 
-        :param uri: the uri
-        :param calendar_id: the calendar id
-        :return: event id
-            or None if there is no event
-        '''
-        event_obj = Pool().get('calendar.event')
-
+        key = (uri, calendar_id)
+        event_id = cls._event_cache.get(key, default=-1)
+        if event_id != -1:
+            return event_id
+        else:
+            event_id = None
         if uri and uri.startswith('Calendars/'):
             calendar, event_uri = (uri[10:].split('/', 1) + [None])[0:2]
             if not calendar_id:
-                calendar_id = self.calendar(uri)
+                calendar_id = cls.calendar(uri)
                 if not calendar_id:
                     return None
-            event_ids = event_obj.search([
-                ('calendar', '=', calendar_id),
-                ('uuid', '=', event_uri[:-4]),
-                ('parent', '=', None),
-                ], limit=1)
-            if event_ids:
-                return event_ids[0]
+            events = Event.search([
+                    ('calendar', '=', calendar_id),
+                    ('uuid', '=', event_uri[:-4]),
+                    ('parent', '=', None),
+                    ], limit=1)
+            if events:
+                event_id = events[0].id
+        cls._event_cache.set(key, event_id)
+        return event_id
 
-    def _caldav_filter_domain_calendar(self, filter):
+    @staticmethod
+    def _caldav_filter_domain_calendar(filter):
         '''
         Return a domain for caldav filter on calendar
-
-        :param filter: the DOM Element of filter
-        :return: a list for domain
         '''
         if not filter:
             return []
@@ -107,12 +107,10 @@
             return [('id', '=', 0)]
         return [('id', '=', 0)]
 
-    def _caldav_filter_domain_event(self, filter):
+    @classmethod
+    def _caldav_filter_domain_event(cls, filter):
         '''
         Return a domain for caldav filter on event
-
-        :param filter: the DOM Element of filter
-        :return: a list for domain
         '''
         res = []
         if not filter:
@@ -174,107 +172,111 @@
                         continue
                     if uri:
                         uri = urllib.unquote_plus(uri)
-                    event_id = self.event(uri)
+                    event_id = cls.event(uri)
                     if event_id:
                         ids.append(event_id)
             return [('id', 'in', ids)]
         return res
 
-    def get_childs(self, uri, filter=None, cache=None):
-        calendar_obj = Pool().get('calendar.calendar')
-        event_obj = Pool().get('calendar.event')
+    @classmethod
+    def get_childs(cls, uri, filter=None, cache=None):
+        pool = Pool()
+        Calendar = pool.get('calendar.calendar')
+        Event = pool.get('calendar.event')
 
         if uri in ('Calendars', 'Calendars/'):
-            domain = self._caldav_filter_domain_calendar(filter)
+            domain = cls._caldav_filter_domain_calendar(filter)
             domain = [['OR',
                     ('owner', '=', Transaction().user),
                     ('read_users', '=', Transaction().user),
                     ],
                 domain]
-            calendar_ids = calendar_obj.search(domain)
-            calendars = calendar_obj.browse(calendar_ids)
+            calendars = Calendar.search(domain)
             if cache is not None:
                 cache.setdefault('_calendar', {})
-                cache['_calendar'].setdefault(calendar_obj._name, {})
-                for calendar_id in calendar_ids:
-                    cache['_calendar'][calendar_obj._name][calendar_id] = {}
+                cache['_calendar'].setdefault(Calendar.__name__, {})
+                for calendar in calendars:
+                    cache['_calendar'][Calendar.__name__][calendar.id] = {}
             return [x.name for x in calendars] + \
                     [x.name + '.ics' for x in calendars]
         if uri and uri.startswith('Calendars/'):
-            calendar_id = self.calendar(uri)
+            calendar_id = cls.calendar(uri)
             if  calendar_id and not (uri[10:].split('/', 1) + [None])[1]:
-                domain = self._caldav_filter_domain_event(filter)
-                event_ids = event_obj.search([
-                    ('calendar', '=', calendar_id),
-                    domain,
-                    ])
-                events = event_obj.browse(event_ids)
+                domain = cls._caldav_filter_domain_event(filter)
+                events = Event.search([
+                        ('calendar', '=', calendar_id),
+                        domain,
+                        ])
                 if cache is not None:
                     cache.setdefault('_calendar', {})
-                    cache['_calendar'].setdefault(event_obj._name, {})
-                    for event_id in event_ids:
-                        cache['_calendar'][event_obj._name][event_id] = {}
+                    cache['_calendar'].setdefault(Event.__name__, {})
+                    for event in events:
+                        cache['_calendar'][Event.__name__][event.id] = {}
                 return [x.uuid + '.ics' for x in events]
             return []
-        res = super(Collection, self).get_childs(uri, filter=filter,
-                cache=cache)
+        childs = super(Collection, cls).get_childs(uri, filter=filter,
+            cache=cache)
         if not uri and not filter:
-            res.append('Calendars')
+            childs.append('Calendars')
         elif not uri and filter:
             if filter.localName == 'principal-property-search':
-                res.append('Calendars')
-        return res
+                childs.append('Calendars')
+        return childs
 
-    def get_resourcetype(self, uri, cache=None):
+    @classmethod
+    def get_resourcetype(cls, uri, cache=None):
         from pywebdav.lib.constants import COLLECTION, OBJECT
         if uri in ('Calendars', 'Calendars/'):
             return COLLECTION
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 return COLLECTION
             return OBJECT
-        elif self.calendar(uri, ics=True):
+        elif cls.calendar(uri, ics=True):
             return OBJECT
-        return super(Collection, self).get_resourcetype(uri, cache=cache)
+        return super(Collection, cls).get_resourcetype(uri, cache=cache)
 
-    def get_displayname(self, uri, cache=None):
-        calendar_obj = Pool().get('calendar.calendar')
+    @classmethod
+    def get_displayname(cls, uri, cache=None):
+        Calendar = Pool().get('calendar.calendar')
         if uri in ('Calendars', 'Calendars/'):
             return 'Calendars'
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
-                return calendar_obj.browse(calendar_id).rec_name
+                return Calendar(calendar_id).rec_name
             return uri.split('/')[-1]
-        elif self.calendar(uri, ics=True):
+        elif cls.calendar(uri, ics=True):
             return uri.split('/')[-1]
-        return super(Collection, self).get_displayname(uri, cache=cache)
+        return super(Collection, cls).get_displayname(uri, cache=cache)
 
-    def get_contenttype(self, uri, cache=None):
-        if self.event(uri) \
-                or self.calendar(uri, ics=True):
+    @classmethod
+    def get_contenttype(cls, uri, cache=None):
+        if cls.event(uri) \
+                or cls.calendar(uri, ics=True):
             return 'text/calendar'
-        return super(Collection, self).get_contenttype(uri, cache=cache)
+        return super(Collection, cls).get_contenttype(uri, cache=cache)
 
-    def get_creationdate(self, uri, cache=None):
-        calendar_obj = Pool().get('calendar.calendar')
-        event_obj = Pool().get('calendar.event')
+    @classmethod
+    def get_creationdate(cls, uri, cache=None):
+        Calendar = Pool().get('calendar.calendar')
+        Event = Pool().get('calendar.event')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if not calendar_id:
-            calendar_id = self.calendar(uri, ics=True)
+            calendar_id = cls.calendar(uri, ics=True)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 if cache is not None:
                     cache.setdefault('_calendar', {})
-                    cache['_calendar'].setdefault(calendar_obj._name, {})
-                    ids = cache['_calendar'][calendar_obj._name].keys()
+                    cache['_calendar'].setdefault(Calendar.__name__, {})
+                    ids = cache['_calendar'][Calendar.__name__].keys()
                     if calendar_id not in ids:
                         ids.append(calendar_id)
                     elif 'creationdate' in cache['_calendar'][
-                            calendar_obj._name][calendar_id]:
-                        return cache['_calendar'][calendar_obj._name][
+                            Calendar.__name__][calendar_id]:
+                        return cache['_calendar'][Calendar.__name__][
                             calendar_id]['creationdate']
                 else:
                     ids = [calendar_id]
@@ -285,30 +287,30 @@
                     red_sql, red_ids = reduce_ids('id', sub_ids)
                     cursor.execute('SELECT id, ' \
                                 'EXTRACT(epoch FROM create_date) ' \
-                            'FROM "' + calendar_obj._table + '" ' \
+                            'FROM "' + Calendar._table + '" ' \
                             'WHERE ' + red_sql, red_ids)
                     for calendar_id2, date in cursor.fetchall():
                         if calendar_id2 == calendar_id:
                             res = date
                         if cache is not None:
-                            cache['_calendar'][calendar_obj._name]\
+                            cache['_calendar'][Calendar.__name__]\
                                     .setdefault(calendar_id2, {})
-                            cache['_calendar'][calendar_obj._name][
+                            cache['_calendar'][Calendar.__name__][
                                 calendar_id2]['creationdate'] = date
                 if res is not None:
                     return res
             else:
-                event_id = self.event(uri, calendar_id=calendar_id)
+                event_id = cls.event(uri, calendar_id=calendar_id)
                 if event_id:
                     if cache is not None:
                         cache.setdefault('_calendar', {})
-                        cache['_calendar'].setdefault(event_obj._name, {})
-                        ids = cache['_calendar'][event_obj._name].keys()
+                        cache['_calendar'].setdefault(Event.__name__, {})
+                        ids = cache['_calendar'][Event.__name__].keys()
                         if event_id not in ids:
                             ids.append(event_id)
                         elif 'creationdate' in cache['_calendar'][
-                                event_obj._name][event_id]:
-                            return cache['_calendar'][event_obj._name][
+                                Event.__name__][event_id]:
+                            return cache['_calendar'][Event.__name__][
                                 event_id]['creationdate']
                     else:
                         ids = [event_id]
@@ -319,37 +321,39 @@
                         red_sql, red_ids = reduce_ids('id', sub_ids)
                         cursor.execute('SELECT id, ' \
                                 'EXTRACT(epoch FROM create_date) ' \
-                            'FROM "' + event_obj._table + '" ' \
+                            'FROM "' + Event._table + '" ' \
                             'WHERE ' + red_sql, red_ids)
                         for event_id2, date in cursor.fetchall():
                             if event_id2 == event_id:
                                 res = date
                             if cache is not None:
-                                cache['_calendar'][event_obj._name]\
+                                cache['_calendar'][Event.__name__]\
                                         .setdefault(event_id2, {})
-                                cache['_calendar'][event_obj._name][
+                                cache['_calendar'][Event.__name__][
                                     event_id2]['creationdate'] = date
                     if res is not None:
                         return res
-        return super(Collection, self).get_creationdate(uri, cache=cache)
+        return super(Collection, cls).get_creationdate(uri, cache=cache)
 
-    def get_lastmodified(self, uri, cache=None):
-        calendar_obj = Pool().get('calendar.calendar')
-        event_obj = Pool().get('calendar.event')
+    @classmethod
+    def get_lastmodified(cls, uri, cache=None):
+        pool = Pool()
+        Calendar = pool.get('calendar.calendar')
+        Event = pool.get('calendar.event')
 
         cursor = Transaction().cursor
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 if cache is not None:
                     cache.setdefault('_calendar', {})
-                    cache['_calendar'].setdefault(calendar_obj._name, {})
-                    ids = cache['_calendar'][calendar_obj._name].keys()
+                    cache['_calendar'].setdefault(Calendar.__name__, {})
+                    ids = cache['_calendar'][Calendar.__name__].keys()
                     if calendar_id not in ids:
                         ids.append(calendar_id)
                     elif 'lastmodified' in cache['_calendar'][
-                            calendar_obj._name][calendar_id]:
-                        return cache['_calendar'][calendar_obj._name][
+                            Calendar.__name__][calendar_id]:
+                        return cache['_calendar'][Calendar.__name__][
                             calendar_id]['lastmodified']
                 else:
                     ids = [calendar_id]
@@ -360,30 +364,30 @@
                     cursor.execute('SELECT id, ' \
                                 'EXTRACT(epoch FROM ' \
                                 'COALESCE(write_date, create_date)) ' \
-                            'FROM "' + calendar_obj._table + '" ' \
+                            'FROM "' + Calendar.__table__ + '" ' \
                                 'WHERE ' + red_sql, red_ids)
                     for calendar_id2, date in cursor.fetchall():
                         if calendar_id2 == calendar_id:
                             res = date
                         if cache is not None:
-                            cache['_calendar'][calendar_obj._name]\
+                            cache['_calendar'][Calendar.__name__]\
                                     .setdefault(calendar_id2, {})
-                            cache['_calendar'][calendar_obj._name][
+                            cache['_calendar'][Calendar.__name__][
                                 calendar_id2]['lastmodified'] = date
                 if res is not None:
                     return res
             else:
-                event_id = self.event(uri, calendar_id=calendar_id)
+                event_id = cls.event(uri, calendar_id=calendar_id)
                 if event_id:
                     if cache is not None:
                         cache.setdefault('_calendar', {})
-                        cache['_calendar'].setdefault(event_obj._name, {})
-                        ids = cache['_calendar'][event_obj._name].keys()
+                        cache['_calendar'].setdefault(Event.__name__, {})
+                        ids = cache['_calendar'][Event.__name__].keys()
                         if event_id not in ids:
                             ids.append(event_id)
                         elif 'lastmodified' in cache['_calendar'][
-                                event_obj._name][event_id]:
-                            return cache['_calendar'][event_obj._name][
+                                Event.__name__][event_id]:
+                            return cache['_calendar'][Event.__name__][
                                 event_id]['lastmodified']
                     else:
                         ids = [event_id]
@@ -396,7 +400,7 @@
                         cursor.execute('SELECT COALESCE(parent, id), ' \
                                     'MAX(EXTRACT(epoch FROM ' \
                                     'COALESCE(write_date, create_date))) ' \
-                                'FROM "' + event_obj._table + '" ' \
+                                'FROM "' + Event._table + '" ' \
                                 'WHERE ' + red_id_sql + ' ' \
                                     'OR ' + red_parent_sql + ' ' \
                                 'GROUP BY parent, id',
@@ -405,23 +409,23 @@
                             if event_id2 == event_id:
                                 res = date
                             if cache is not None:
-                                cache['_calendar'][event_obj._name]\
+                                cache['_calendar'][Event.__name__]\
                                         .setdefault(event_id2, {})
-                                cache['_calendar'][event_obj._name][
+                                cache['_calendar'][Event.__name__][
                                     event_id2]['lastmodified'] = date
                     if res is not None:
                         return res
-        calendar_ics_id = self.calendar(uri, ics=True)
+        calendar_ics_id = cls.calendar(uri, ics=True)
         if calendar_ics_id:
             if cache is not None:
                 cache.setdefault('_calendar', {})
-                cache['_calendar'].setdefault(calendar_obj._name, {})
-                ids = cache['_calendar'][calendar_obj._name].keys()
+                cache['_calendar'].setdefault(Calendar.__name__, {})
+                ids = cache['_calendar'][Calendar.__name__].keys()
                 if calendar_ics_id not in ids:
                     ids.append(calendar_ics_id)
                 elif 'lastmodified ics' in cache['_calendar'][
-                        calendar_obj._name][calendar_ics_id]:
-                    return cache['_calendar'][calendar_obj._name][
+                        Calendar.__name__][calendar_ics_id]:
+                    return cache['_calendar'][Calendar.__name__][
                         calendar_ics_id]['lastmodified ics']
             else:
                 ids = [calendar_ics_id]
